#pragma semicolon 1

#include <ws_store>
#include <sourcemod>
#include <sdktools>
#include <morecolors>

public Plugin:myinfo = 
{
	name	= "STORE (Neon)",
	author	= "Tokami (World-Source.Ru)",
	version = "1.0"
};

new g_Price, g_CategoryID, g_ItemID;

enum eNeon
{	
	String:Name[64],
	colorr,		
	colorg,	
	colorb,		
	colora	
}

new g_Neons[201][eNeon];

new g_dClientNeon[MAXPLAYERS+1];
new bool:NeonOnOff[MAXPLAYERS+1];
new bool:NeonBuy[MAXPLAYERS+1];
new g_Array_Neon[MAXPLAYERS+1];
new maxNeon = -1;

public OnPluginStart()
{
	CreateTimer(1.0, START);
	HookEvent("player_spawn",	player_spawn);
	HookEvent("player_death", player_death);
	RegConsoleCmd("sm_neon", sm_neon);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_neon");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_neon.txt"))
		SetFailState("Error in cfg/store/modules/store_neon.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");

	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	new g_iNumNeon = 1;
	KvGotoFirstSubKey(kv);
	KvGotoFirstSubKey(kv);
	do
	{
		KvGetSectionName(kv, g_Neons[g_iNumNeon][Name], 64);

		g_Neons[g_iNumNeon][colorr] =	KvGetNum(kv, "r");
		g_Neons[g_iNumNeon][colorg] =	KvGetNum(kv, "g");
		g_Neons[g_iNumNeon][colorb] =	KvGetNum(kv, "b");
		g_Neons[g_iNumNeon][colora] =	KvGetNum(kv, "a");
		
		++g_iNumNeon;
	}
	while (KvGotoNextKey(kv));
	
	maxNeon = g_iNumNeon - 1;
	
	CloseHandle(kv);

	//////////////////
	return Plugin_Stop;
}

public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID)
		wS_OnClientSelect(client, LastMenuItem:MI_InCategory);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID)
		wS_OnClientSelect(client, LastMenuItem:MI_Main);
}

stock wS_OnClientSelect(client, LastMenuItem:MI)
{
	DisplayMenu(BuildNeonMenu(client), client, 0);
}

stock Handle:BuildNeonMenu(client)
{
	decl String:buffer[255];
	decl String:bufferindex[5];
	new Handle:menu = CreateMenu(BuyNeonMenuHandler);
	SetMenuTitle(menu, "Покупка неона [Кредиты: %d]\n \n", STORE_GetCredits(client));
	for (new i = 1; i <= maxNeon; i++)
	{
		Format(buffer, sizeof(buffer), "%s [%d]", g_Neons[i][Name], g_Price);
		IntToString(i, bufferindex, sizeof(bufferindex));
		
		AddMenuItem(menu, bufferindex, buffer);
	}
			
	SetMenuExitBackButton(menu, true);
	SetMenuExitButton(menu, true);
	return menu;
}

public BuyNeonMenuHandler(Handle:mainmenu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select)
	{
		decl String:info[32];
		GetMenuItem(mainmenu, param2, info, sizeof(info));
		
		if (g_Price > 0)
		{
			new credits = STORE_GetCredits(client);

			if (credits < g_Price)
			{
				PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
				STORE_ShowMenu(client, LastMenuItem:MI_InCategory);
				return;
			}

			if (!STORE_SetCredits(client, (credits - g_Price)))
			{
				LogError("Не удалось установить кредиты игроку '%N'", client);
				return;
			}
		}
		
		new index = StringToInt(info);
		
		g_dClientNeon[client] = index;
		
		if(NeonOnOff[client])
		{
			Void_KillNeon(client);
			NeonColor(client);
		}
		else if(IsPlayerAlive(client)) NeonColor(client);
		
		NeonOnOff[client] = true;
		NeonBuy[client] = true;
		STORE_ShowMenu(client, LastMenuItem:MI_InCategory);
	}
	else if (action == MenuAction_Cancel && param2 == MenuCancel_ExitBack)
	{
		STORE_ShowMenu(client, LastMenuItem:MI_InCategory);
	}	
	else if (action == MenuAction_End)
	{
		CloseHandle(mainmenu);
	}	
}

bool:ReadColor(client, color[4]) //выводим цвета в color[4]
{    
	color[0] = g_Neons[g_dClientNeon[client]][colorr];
	color[1] = g_Neons[g_dClientNeon[client]][colorg];
	color[2] = g_Neons[g_dClientNeon[client]][colorb];
	color[3] = g_Neons[g_dClientNeon[client]][colora];
	return true;
} 

NeonColor(client)
{
	new color[4];
	if (IsClientInGame(client) && IsPlayerAlive(client) && ReadColor(client, color))
	{	
		decl String:str_color[25]; 
		Format(str_color, 25, "%d %d %d %d", g_Neons[g_dClientNeon[client]][colorr], g_Neons[g_dClientNeon[client]][colorg], g_Neons[g_dClientNeon[client]][colorb], g_Neons[g_dClientNeon[client]][colora]);
		
		decl String:_sTemp[64], String:_sOriginal[64];
		GetEntPropString(client, Prop_Data, "m_iName", _sOriginal, sizeof(_sOriginal));
		Format(_sTemp, sizeof(_sTemp), "SupporterTrails_%d", GetClientUserId(client));
		DispatchKeyValue(client, "targetname", _sTemp);
		
		decl Float:g_fAngle[3], Float:g_fOrigin[3], Float:_fTemp[3] = {0.0, 90.0, 0.0}, Float:_fVemp[3] = {0.0, 0.0, 0.0};
		GetEntPropVector(client, Prop_Data, "m_angAbsRotation", g_fAngle);
		SetEntPropVector(client, Prop_Data, "m_angAbsRotation", _fTemp);
	
		new iEntity = CreateEntityByName("light_dynamic");
		if(iEntity > 0 && IsValidEntity(iEntity))
		{
			g_Array_Neon[client] = iEntity;
			DispatchKeyValue(iEntity, "parentname", _sTemp);
			DispatchKeyValue(iEntity, "_light", str_color); 
			DispatchKeyValue(iEntity, "brightness", "10"); 
			DispatchKeyValueFloat(iEntity, "spotlight_radius", 360.0); 
			DispatchKeyValueFloat(iEntity, "distance", 50.0); 
			DispatchKeyValue(iEntity, "style", "0");
			DispatchSpawn(iEntity);
			
			GetClientAbsOrigin(client, g_fOrigin);
			AddVectors(g_fOrigin, _fVemp, g_fOrigin);
			TeleportEntity(iEntity, g_fOrigin, _fTemp, NULL_VECTOR);
			
			SetVariantString(_sTemp);
			AcceptEntityInput(iEntity, "SetParent", iEntity, iEntity);
		}
		
		SetEntPropVector(client, Prop_Data, "m_angAbsRotation", g_fAngle);
		DispatchKeyValue(client, "targetname", _sOriginal);
	}
}

Void_KillNeon(client)
{
	if(g_Array_Neon[client] != -1)
	{
		new iEntity = g_Array_Neon[client];
		if(iEntity > 0 && IsValidEntity(iEntity))
			AcceptEntityInput(iEntity, "Kill");
		
		g_Array_Neon[client] = -1;
	}	
}

public Action:player_death(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(NeonOnOff[client])
	{
		Void_KillNeon(client);
	}
}

public player_spawn(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(NeonOnOff[client])
	{
		Void_KillNeon(client);
		NeonColor(client);
	}
}

public Action:sm_neon(client, args)
{
	if(client > 0)
	{
		if(NeonBuy[client])
		{
			if(NeonOnOff[client])
			{
				NeonOnOff[client] = false; 
				if(IsPlayerAlive(client)) Void_KillNeon(client); 
				CPrintToChat(client, "{green}[Store] {default}Вы успешно выключили неон!");
			}
			else
			{
				NeonOnOff[client] = true; 
				if(IsPlayerAlive(client)) NeonColor(client); 
				CPrintToChat(client, "{green}[Store] {default}Вы успешно включили неон!");
			}
		}
		else CPrintToChat(client, "{green}[Store] {default}Вы не покупали неон!");
	}
	return Plugin_Handled;
}